<template lang="pug">
.input
    input.form-control(
        :class="{'form-control-icon' : icon, 'form-control-datepicker': isDatepicker, 'is-invalid' : isInvalid}" 
        :placeholder="placeholder" 
        :value="value"
        :disabled="disabled || loading"
        :readonly="readonly || isDatepicker"
        @click="onClick"
        @input="onInput"
    )
    .input-icon(v-if="icon")
        .material-icons {{icon}}
    .input-loading(v-if="loading")
        b-spinner(small)
</template>

<script>
export default {
    name: 'AppInput',
    data: () => ({
        inputValue: null,
    }),
    props: {
        placeholder: {
            type: String,
            default: null,
        },
        value: {
            type: String,
            default: null,
        },
        icon: {
            type: String,
            default: null,
        },
        disabled: {
            type: Boolean,
            default: false,
        },
        loading: {
            type: Boolean,
            default: false,
        },
        readonly: {
            type: Boolean,
            default: false,
        },
        isDatepicker: {
            type: Boolean,
            default: false,
        },
        isInvalid: {
            type: Boolean,
            default: false,
        },
    },
    methods: {
        onClick(event) {
            if (this.loading) return
            this.$emit('click', event)
        },
        onInput(event){
            this.$emit('input',event.target.value)
        }
    },
}
</script>

<style lang="scss" scoped>
@import './index.scss';
</style>
